// Package abstract ...
//
// Description : abstract ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2023-02-01 14:21
package abstract

import "git.zhangdeman.cn/zhangdeman/event"

// ISendEventHandler 发送事件处理器
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 14:21 2023/2/1
type ISendEventHandler interface {
	// Send ...
	//
	// Author : go_developer@163.com<白茶清欢>
	//
	// Date : 14:21 2023/2/1
	// 事件发送成功之后, 可以返回一些业务数据, 这些业务数据会回调给SuccessCallback
	// 事件发送成功之后, 可以返回一些业务数据 以及 err, 这些业务数据会回调给FailCallback
	Send(data []byte) (map[string]interface{}, error)

	// SuccessCallback 事件发送成功的回调
	//
	// Author : go_developer@163.com<白茶清欢>
	//
	// Date : 14:21 2023/2/1
	SuccessCallback(data map[string]interface{})

	// FailCallback 事件发送失败的回调
	//
	// Author : go_developer@163.com<白茶清欢>
	//
	// Date : 14:22 2023/2/1
	FailCallback(data map[string]interface{}, err error)

	// NoSendCallback 不需要发送事件的回调
	//
	// Author : go_developer@163.com<白茶清欢>
	//
	// Date : 15:26 2023/2/2
	NoSendCallback(data interface{}, res event.SendResult)
}
